codeforces 607B. Zuma 区间dp】的更多相关文章

题目链接 给一个长度为n的序列, 每一次可以消去其中的一个回文串, 问最少几次才可以消完. 代码很清楚 #include <iostream> #include <vector> #include <cstdio> #include <cstring> #include <algorithm> #include <cmath> #include <map> #include <set> #include <…
Genos recently installed the game Zuma on his phone. In Zuma there exists a line of n gemstones, the i-th of which has color ci. The goal of the game is to destroy all the gemstones in the line as quickly as possible. In one second, Genos is able to…
题意 题目链接 Sol 裸的区间dp,转移的时候判一下两个字符是否相等即可 #include<bits/stdc++.h> #define Pair pair<int, int> #define MP(x, y) make_pair(x, y) #define fi first #define se second #define LL long long #define ull unsigned long long #define Fin(x) {freopen(#x".…
Palindromic characteristics of string s with length |s| is a sequence of |s|integers, where k-th number is the total number of non-empty substrings of s which are k-palindromes. A string is 1-palindrome if and only if it reads the same backward as fo…
题目大意:依照祖玛的玩法(任意选颜色),给出一段区间.问最少用多少个球可以把全部颜色块都消除. 思路:把输入数据依照连续的块处理.保存成颜色和数量.然后用这个来DP.我们知道,一个单独的块须要两个同样的颜色能够消去,对于这种块f[i][i] = 2.其余的>=2个的块仅仅须要一个,这种块f[i][i] = 1. 转移就比較简单了,依照区间DP的一般思想,最外层循环的是区间长度.中间循环的是起始位置,最后循环的是松弛变量. 特殊情况是这个区间的两边是同一种颜色,多加一个转移方程. CODE: #i…
You are given a line of nn colored squares in a row, numbered from 11 to nn from left to right. The ii-th square initially has the color cici. Let's say, that two squares ii and jj belong to the same connected component if ci=cjci=cj, and ci=ckci=ck …
题目大概说,有n个颜色的宝石,可以消除是回文串的连续颜色序列,问最少要几下才能全部消除. 自然想到dp[i][j]表示序列i...j全部消除的最少操作数 有几种消除的方式都能通过枚举k(i<=k<j)从min(dp[i][k],dp[k+1][j])转移 还有一种先消除中间的,剩余两部分组成回文串再消除,这种消除方式转移不会..想到的时间复杂度太高.. 看了tourist的代码,发现神的转移好简洁,这种方式就是从dp[i+1][j-1](c[i]=c[j])转移的 应该可以这么理解,如果c[i…
D. Zuma   Genos recently installed the game Zuma on his phone. In Zuma there exists a line of n gemstones, the i-th of which has color ci. The goal of the game is to destroy all the gemstones in the line as quickly as possible. In one second, Genos i…
以下是从中文翻译成人话的题面: 给定一个长度小于等于500的序列,每个数字代表一个颜色,每次可以消掉一个回文串,问最多消几次可以消完? (7.16) 这个题从洛谷pend回来以后显示有103个测试点(满屏的AC好爽-- 上午考试的时候这个题直接用马拉车暴力贪心骗了十五分.然而每次消掉一个最长的回文串并不一定是最优的策略,这道题要用DP来做. 设计状态f[l, r]表示消掉原串这段区间内串的最小代价.老师说直接递推不好搞,应该是因为这个循环的阶段不好确定.考虑用记忆化搜索来转移. 四种情况: 1.…
用solve(l, r, prefix)代表区间l开始r结束.带了prefix个前缀str[l](即l前面的串化简完压缩成prefix-1个str[l],加上str[l]共有prefix个)的最大值. 每层可以选择: 1.直接“提现”,把起始位和前面的“存款”直接提出来,再计算l+1-r区间的值: 2.继续“存款”,枚举和str[l]相同的位置,把中间先合并了然后删了,把prefix+1,即把枚举的这位和之前的存款粘在一起,然后计算i-r的值,更新ans. 乍一想会觉得每次只把两个粘在一起这行吗…